# mongoc_uri_set_mechanism_properties()

## Synopsis

    bool
    mongoc_uri_set_mechanism_properties (mongoc_uri_t *uri,
                                         const bson_t *properties);

## Parameters

- `uri`: A mongoc_uri_t.
- `properties`: A `bson_t` .

## Description

Replaces all the options in URI’s “authMechanismProperties” after the URI has been parsed from a string.

## Returns

Returns false if the option cannot be set, for example if `properties` is not valid BSON data.

## Example

    mongoc_uri_t *uri;
    bson_t props = BSON_INITIALIZER;

    uri = mongoc_uri_new (
       "mongodb://user%40DOMAIN.COM:password@localhost/?authMechanism=GSSAPI"
       "&authMechanismProperties=SERVICE_NAME:other,CANONICALIZE_HOST_NAME:true");

    /* replace all options: replace service name "other" with "my_service", unset
     * "CANONICALIZE_HOST_NAME" and accept its default.
     */
    BSON_APPEND_UTF8 (&props, "SERVICE_NAME", "my_service");
    mongoc_uri_set_mechanism_properties (uri, &props);

    bson_destroy (&props);

## See Also

GSSAPI (Kerberos) Authentication and mongoc_uri_get_mechanism_properties()

### See Also:

authentication

mongoc_uri_get_auth_mechanism

mongoc_uri_get_auth_source

mongoc_uri_get_mechanism_properties

mongoc_uri_set_auth_mechanism

mongoc_uri_set_auth_source